package jalview.analysis;

import jalview.datamodel.SequenceI;
import java.util.Hashtable;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: Dundee University</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SeqsetUtils
{
  public static Hashtable uniquify(SequenceI[] sequences)
  {
    // Generate a safely named sequence set and a hash to recover the sequence names
    Hashtable map = new Hashtable();
    for (int i = 0; i < sequences.length; i++)
    {
      String safename = new String("Sequence" + i);
      map.put(safename, sequences[i].getName());
      sequences[i].setName(safename);
    }
    return map;
  }

  public static boolean deuniquify(Hashtable map, SequenceI[] sequences)
  {
    // recover unsafe sequence names for a sequence set
    boolean allfound = true;
    for (int i = 0; i < sequences.length; i++)
    {
      if (map.containsKey(sequences[i].getName()))
      {
        String unsafename = (String) map.get(sequences[i].getName());
        sequences[i].setName(unsafename);
      }
      else
      {
        allfound = false;
      }
    }
    return allfound;
  }

}
